/*
** 		Sambar Server JAVA Engine Implementation
**
**		Confidential Property of Tod Sambar
**		(c) Copyright Tod Sambar 1999
**		All rights reserved.
*/
package com.sambar.javaeng;

import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.sambar.javaeng.SambarAPI;

class SambarOutputStream extends ServletOutputStream 
{
	private long 				req;
	private boolean 			noHeaders = true;
	private SambarConnection 	sconn;
  
	public SambarOutputStream(long req, SambarConnection sconn)
	{
		this.req = req;
		this.sconn = sconn;
	}
  
	public void write(int b) throws IOException 
	{
		sconn.sendHttpHeaders(); 
		SambarAPI.putb(req, b);
	}
  
	public void write(byte b[], int off, int len) throws IOException 
	{
		sconn.sendHttpHeaders(); 
		SambarAPI.puta(req, b, off, len);
	}
  
	public void flush() throws IOException 
	{
		SambarAPI.flush(req);
	}
  
	public void close() throws IOException 
	{
		sconn.sendHttpHeaders(); 
		SambarAPI.close(req);
	}
}
